#include <iostream>
using namespace std;
#include <stdlib.h>

// Bitte hier die Klasse maxFive definieren:

class maxFive {
	private:
		int MaxSet[5];
	public:
		// Konstruktor:
		maxFive()
		{
			for(int i = 0; i < 5; i++)
				MaxSet[i] = -1;
		}

		// Methode zum Speichern eines Elementes:
		void store(int n)
		{
			// Beachte: Negative Werte brauchen nicht extra
			// behandelt zu werden, weil sie aufgrund der
			// Initialisierung mit -1 niemals eingefuegt werden
			// (sie sind <= den schon vorhandenen Werten).

			// Erste Position suchen, bei der der einzufuegende
			// Wert den bereits gespeicherten Wert schlaegt.
			// Dann den verdraengten Wert einfuegen (funktioniert
			// immer eins tiefer, ausser beim letzten Wert):
			for(int i = 0; i < 5; i++) {
				if(n > MaxSet[i]) {
					int oldValue = MaxSet[i];
					MaxSet[i] = n;
					n = oldValue;
				}
			}
		}

		// Methode zum Abfragen der groessten Werte:
		int top(int i)
		{
			// Index ausserhalb der Grenzen behandeln:
			if(i < 0 || i >= 5)
				return -1;
			else
				return MaxSet[i];

		}
};

// Das Hauptprogramm dient zum Testen.
// Es sollte moeglichst nicht veraendert werden.
// Zumindest muss es am Ende wieder genau den gegebenen Programmcode enthalten:

int main()
{
	maxFive a;
	maxFive b;
	maxFive c;
	maxFive d;
	int erg;

	// Erster Test: Beispiel aus dem Aufgabenblatt:
	cout << "Erster Test.\n";
	a.store(10);
	a.store(8);
	a.store(12);
	a.store(5);
	a.store(15);
	a.store(14);
	a.store(20);
	a.store(15);

	erg = a.top(0);
	if(erg != 20) {
		cout << "Fehler bei a.top(0). Soll 20 sein, war aber " << erg
			<< ".\n";
		exit(1);
	}

	erg = a.top(1);
	if(erg != 15) {
		cout << "Fehler bei a.top(1). Soll 15 sein, war aber " << erg
			<< ".\n";
		exit(1);
	}

	erg = a.top(2);
	if(erg != 15) {
		cout << "Fehler bei a.top(2). Soll 15 sein, war aber " << erg
			<< ".\n";
		exit(1);
	}

	erg = a.top(3);
	if(erg != 14) {
		cout << "Fehler bei a.top(3). Soll 14 sein, war aber " << erg
			<< ".\n";
		exit(1);
	}

	erg = a.top(4);
	if(erg != 12) {
		cout << "Fehler bei a.top(4). Soll 12 sein, war aber " << erg
			<< ".\n";
		exit(1);
	}

	// Zweiter Test: Ganz leeres Objekt, Ueberschreitung der Grenzen:
	cout << "Zweiter Test.\n";
	for(int i = -3; i < 100; i++) {
		erg = b.top(i);
		if(erg != -1) {
			cout << "Fehler bei b.top(" << i << "): ";
			cout << "Ergebnis muss -1 sein, war aber " << erg <<
				"!\n";
			exit(1);
		}
	}

	// Dritter Test: Aufsteigend einfuegen:
	cout << "Dritter Test.\n";
	for(int i = 1; i <= 100; i++)
		c.store(i);
	for(int i = 0; i < 5; i++) {
		erg = c.top(i);
		if(erg != 100-i) {
			cout << "Fehler bei c.top(" << i << "): ";
			cout << "Muss " << 100-i << " sein, war aber "
				<< erg << ".\n";
			exit(1);
		}
	}

	// Vierter Test: Absteigend einfuegen:
	cout << "Vierter Test.\n";
	for(int i = 100; i > 0; i--)
		d.store(i);
	for(int i = 0; i < 5; i++) {
		erg = d.top(i);
		if(erg != 100-i) {
			cout << "Fehler bei d.top(" << i << "): ";
			cout << "Muss " << 100-i << " sein, war aber "
				<< erg << ".\n";
			exit(1);
		}
	}

	// Und nochmal testen, dass sich bei a nichts geaendert hat:
	cout << "Fuenfter Test.\n";
	erg = a.top(0);
	if(erg != 20) {
		cout << "Fehler bei a.top(0): Muss 20 sein, war aber "
			<< erg << ".\n";
		exit(1);
	}

	// Ok:
	cout << "\nHerzlichen Glueckwunsch. Alle Tests bestanden.\n";

	// Ende von main:
	return 0;
}
